Codeforces 677E - Vanya and Balloons

题意:类似炸弹人游戏,但是十字的炸弹弹道都是等长的(就是4个方向的长度一样)(可以炸十、×),然后结果是所能炸到的每个格子的乘积的最大值。

分析:一眼看下去就是DP了,但有与涉及8个方向,所以就要分别DP8个方向。每个方向就是一个一维的DP。
       还有要大小的比较就要利用到log了,因为要比较【2^k1 和 3^k2(k1>k2)】的大小,直接算是不现实的,所以利用log转化成---》【k1*log(2) 和 k2*log(3)】的大小比较。

吐槽时间:这代码真难打吖,调试n久。。。。。(内心是崩溃的)

 

#include <bits/stdc++.h>
using namespace std;
typedef long long LL;
const int MOD = 1e9 + 7;
const int maxn = 1000 + 10;

struct Node
{
    int n1,n2,n3,l;
    Node(){n1=n2=n3=l=0;}
    Node(char c)
    {
        n1=n2=n3=l=0;
        if(c==‘1‘) n1=l=1;
        else if(c==‘2‘) n2=l=1;
        else if(c==‘3‘) n3=l=1;
    }
    Node operator+(Node &a)
    {
        Node t;
        t.n1=n1+a.n1; t.n2=n2+a.n2; t.n3=n3+a.n3;
        return t;
    }
    Node operator-(Node &a)
    {
        Node t;
        t.n1=n1-a.n1; t.n2=n2-a.n2; t.n3=n3-a.n3;
        return t;
    }
};

char w[maxn][maxn];
Node dp[8][maxn][maxn], ans;
int dy[8]={-1,-1,0,1,1,1,0,-1};
int dx[8]={0,-1,-1,-1,0,1,1,1};
int n;

LL quick_(LL x, int n)
{
    if(x==0) return 0;
    LL ans = 1;
    while(n)
    {
        if(n&1) ans=ans*x%MOD;
        x=x*x%MOD;
        n>>=1;
    }
    return ans;
}
void prin(Node no)
{
    cout<<"n1:"<<no.n1<<" n2:"<<no.n2<<" n3:"<<no.n3<<endl;
}

void init()
{
    memset(w, ‘0‘, sizeof(w));

    int i, j, z, x, y;
    scanf("%d", &n);
    for(i=1;i<=n;++i) scanf("%s", w[i]+1);
    for(i=1;i<=n;++i) for(j=1;j<=n;++j) for(z=0;z<8;++z) dp[z][i][j]=Node(w[i][j]);
    //分别dp8个方向
    for(z=0;z<4;++z)
        for(i=1;i<=n;++i)
            for(j=1;j<=n;++j)
            {
                x=i+dx[z]; y=j+dy[z];
                if(w[i][j]!=‘0‘)
                {
                    dp[z][i][j]=dp[z][i][j]+dp[z][x][y];
                    dp[z][i][j].l+=dp[z][x][y].l+1;
                }
            }
    for(z=4;z<6;++z)
        for(i=n;i>=1;--i)
            for(j=n;j>=1;--j)
            {
                x=i+dx[z]; y=j+dy[z];
                if(w[i][j]!=‘0‘)
                {
                    dp[z][i][j]=dp[z][i][j]+dp[z][x][y];
                    dp[z][i][j].l+=dp[z][x][y].l+1;
                }
            }
    for(z=6;z<8;++z)
        for(i=n;i>=1;--i)
            for(j=1;j<=n;++j)
            {
                x=i+dx[z]; y=j+dy[z];
                if(w[i][j]!=‘0‘)
                {
                    dp[z][i][j]=dp[z][i][j]+dp[z][x][y];
                    dp[z][i][j].l+=dp[z][x][y].l+1;
                }
            }
}
int main()
{
    double tan1, tan2, tan=0;
    int i, j, z, lnor, lrot, x, y;

    init();
    for(i=1;i<=n;++i)
        for(j=1;j<=n;++j)
        {
            Node no, ro;
            lrot=lnor=maxn;
            //normal
            for(z=0;z<8;z+=2) lnor=min(lnor, dp[z][i][j].l), no=no+dp[z][i][j];
            for(z=0;z<8;z+=2)
            {
                if(dp[z][i][j].l>lnor)
                {
                    x=i+dx[z]*(lnor); y=j+dy[z]*(lnor);
                    no=no-dp[z][x][y];
                }
            }
            //rotate
            for(z=1;z<8;z+=2) lrot=min(lrot, dp[z][i][j].l), ro=ro+dp[z][i][j];
            for(z=1;z<8;z+=2)
            {
                if(dp[z][i][j].l>lrot)
                {
                    x=i+dx[z]*(lrot); y=j+dy[z]*(lrot);
                    ro=ro-dp[z][x][y];
                }
            }
            //中间加多的
            if(w[i][j]==‘1‘) ro.n1-=3,no.n1-=3;
            else if(w[i][j]==‘2‘) ro.n2-=3, no.n2-=3;
            else if(w[i][j]==‘3‘) ro.n3-=3, no.n3-=3;

            Node t;
            tan1=no.n2*log(2)+no.n3*log(3);
            tan2=ro.n2*log(2)+ro.n3*log(3);
            if(tan1>tan) ans=no,tan=tan1;
            if(tan2>tan) ans=ro,tan=tan2;
            if(fabs(tan-0)<1e-9)
            {
                if(ans.n1==0&&no.n1!=0)ans=no;
                else if(ans.n1==0&&ro.n1!=0) ans=ro;
            }
        }

    LL res=quick_(2,ans.n2)*quick_(3,ans.n3)%MOD;
    if(ans.n2==0&&ans.n3==0&&ans.n1==0) res=0;
    cout<<res<<endl;

}
时间: 2024-11-08 08:41:25

Codeforces 677E - Vanya and Balloons的相关文章

codeforces 492E. Vanya and Field(exgcd求逆元)

题目链接:codeforces 492e vanya and field 留个扩展gcd求逆元的板子. 设i,j为每颗苹果树的位置,因为gcd(n,dx) = 1,gcd(n,dy) = 1,所以当走了n步后,x从0~n-1,y从0~n-1都访问过,但x,y不相同. 所以,x肯定要经过0点,所以我只需要求y点就可以了. i,j为每颗苹果树的位置,设在经过了a步后,i到达了0,j到达了M. 则有 1----------------------(i + b * dx) % n = 0 2------

Codeforces 492E Vanya and Field(拓展欧几里得)

题目链接:Codeforces 492E Vanya and Field 通过拓展欧几里得算法求出每个位置在移动过程中,在x为0时,y的位置.统计相应y坐标最多的即为答案. #include <cstdio> #include <cstring> #include <algorithm> using namespace std; const int maxn = 1e6 + 5; const int maxm = 1e5 + 5; typedef long long l

CodeForces 552C Vanya and Scales

Vanya and Scales Time Limit:1000MS     Memory Limit:262144KB     64bit IO Format:%I64d & %I64u Submit Status Practice CodeForces 552C Description Vanya has a scales for weighing loads and weights of masses w0, w1, w2, ..., w100 grams where w is some

CodeForces - 552E Vanya and Brackets

Vanya and Brackets Time Limit: 1000MS   Memory Limit: 262144KB   64bit IO Format: %I64d & %I64u Description Vanya is doing his maths homework. He has an expression of form , where x1, x2, ..., xn are digits from 1 to 9, and sign represents either a p

Codeforces 552E Vanya and Brackets(贪心 + 表达式计算)

题目链接 Vanya and Brackets 题目大意是给出一个只由1-9的数.乘号和加号组成的表达式,若要在这个表达式中加上一对括号,求加上括号的表达式的最大值. 我们发现,左括号的位置肯定是最左端或者某个乘号右边,右括号的位置肯定是最右段或者某个乘号左边. 而乘号最多只有15个,那么暴力枚举就可以了. #include <bits/stdc++.h> using namespace std; #define rep(i, a, b) for (int i(a); i <= (b);

codeforces 492C. Vanya and Exams 解题报告

题目链接:http://codeforces.com/problemset/problem/492/C 题目意思:给出 3 个整数:n,  r,  avg.然后有 n 行,每行有两个数:第 i 行有 ai 和 bi.表示如果写 bi 篇文章那么可以在 ai 这个分数上增加 1 分.可以增加好多次,但是前提是加完得到的分数不能超过 r.要使得 n 个exam 的分数平均分至少达到avg时需要写的最少文章是多少篇. 解决方法很简单,贪心即可. 我们当然希望写的文章越少越好,所以先对文章从小到大排序.

codeforces 342C Cupboard and Balloons(公式题)

转载请注明出处: http://www.cnblogs.com/fraud/          ——by fraud C. Cupboard and Balloons A girl named Xenia has a cupboard that looks like an arc from ahead. The arc is made of a semicircle with radius r (the cupboard's top) and two walls of height h (the

codeforces 492D Vanya and Computer Game(额。。。数学题?水题吧)

传送门:点击打开链接 题目大意: 有2个人在打怪,攻击频率分别是x,y.小怪有num点血.问死的时候是谁打死的.如果同时出手 输出Both. 解题思路: 在一秒内考虑这个问题(一秒是循环节). 假设攻击时刻的分母x*y.那么容易得到每个人的攻击时刻(在一秒内). 然后如果有一个时刻有重复.那么肯定是2个人同时在打. 排个序就好了. 这是D题么...我觉得最多是C题难度,吐槽一下... #include <cstdio> #include <vector> #include <

codeforces C. Vanya and Scales

C. Vanya and Scales Vanya has a scales for weighing loads and weights of masses w0, w1, w2, ..., w100 grams where w is some integer not less than 2(exactly one weight of each nominal value). Vanya wonders whether he can weight an item with mass m usi